package com.android.ptplib;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.os.Environment;
import android.util.Log;

public class UsbLogger {
	
	public static boolean logToFile 		= false;
	public static String  usbLogFileName	= Environment.getExternalStorageDirectory().getAbsolutePath() +"/PtpLibLog.txt";
	
	public static void log (String tag, String message){
		Log.d (tag, message);
		logInFile (message);
	}
	

	public static void logInFile (String message){
		if (logToFile) {
			SimpleDateFormat formatter = new SimpleDateFormat ("yyyy-MM-dd  HH:mm:ss.SSSS");
			Date currentTime = new Date();
			String ZeitInfo = formatter.format(currentTime); 
			writeString (ZeitInfo +";" +message +"\r\n", usbLogFileName, true);
		}
	}
	
	
	public static void logInFile (String tag, String message){
		logInFile (message);
		
	}
	public static void logInFile (String tag, String message, byte[] data, int length){
		logInFile (message, data, length);
	}

		
	public static void logInFile (String message, byte[] data, int length){
		if (logToFile) {
			SimpleDateFormat formatter = new SimpleDateFormat ("yyyy-MM-dd  HH:mm:ss.SSSS");
			Date currentTime = new Date();
			String ZeitInfo = formatter.format(currentTime); 
			String dataS    = "";
			for (int i = 0; i < length; i++){
				if (i % 8 == 0)  dataS += " ";
				if (i > 0 && i % 16 == 0) dataS += "\r\n";
				dataS += String.format(" %02x", data [i]);
			}
			writeString (ZeitInfo +";" +message +";" +dataS +"\r\n", usbLogFileName, true);
		}
	}

	
	// methods from SystemUtils
	
	/** saves String s to file fileName, if necessary creates directory 
	 * 
	 * @param s
	 * @param fileName
	 * @return
	 */
	public static boolean writeString (String s, String fileName, boolean append){
		if (chkDir(fileName)){
			try{
				File file = new File(fileName);
				FileWriter fw = new FileWriter(file, append);
				fw.write(s);
				fw.close();
				return true;
			}
			catch( IOException e )
			{
				e.printStackTrace();
				return false;
			}
		} else return false;
	}
	
	
	/** creates directory of filename if necessary and checks existance
	 * 
	 * @param Filename
	 * @return
	 */
	private static boolean chkDir (String Filename){
		String dirS = stripFileDir(Filename);
		if (dirS != null && dirS.trim().length() > 0){
			File dir = new File (dirS);
			if (!dir.exists()) dir.mkdirs(); // Create Directory if necessary
			return dir.exists();
		} else return true;
	}

	/** gets path without file name
	 * 
	 * @param path
	 * @return
	 */
	private static String stripFileDir (String path){
		if (path.contains("/")) { return path.substring(0, path.lastIndexOf('/'));}
		else return "";
	}



}
